\prog:Pict84e|Ecrit (10 ms) et lit l'EEPROM du F84
; Le programme crit de 22  22+16 dans 0..16
.Proc	16F84
.Ref	16F84

.Macro	Bank0
	Clr	Status:#RP0
.Endmacro
.Macro	Bank1
	Set	Status:#RP0
.Endmacro

\var;Ports| 
\b;PortA
bS1	= 4
DirA	= 2'01111	; Adresse sur PortA
DirB	= 0	; affichage data
.macro	S1On
	Set	PortA:#bS1
.endmacro
.macro	S1Off
	Clr	PortA:#bS1
.endmacro

\var; | 
.Loc	DebVar
C0:	.16	1
C1:	.16	1
C2:	.16	1
C3:	.16	1

\prog;Programme| 
.Loc	0
Start:
	Move	#DirA,W
	Move	W,TrisA
	Move	#DirB,W
	Move	W,TrisB
	Move	#16'22,W
	Move	W,EEData
	Clr	EEAdr
	Move	#16,W
	Move	W,C0
Wri:
s1on
	Call	WrEeprom
s1off
	Inc	EEadr
	Inc	EEdata
	DecSkip,Eq C0
	Jump	Wri
Read:
	Clr	EEAdr
	Move	#16,W
	Move	W,C0
L$:
	Call	EERead
; Xor	#-1,W  ; Les LEDs de Picg inversent
	Move	W,PortB
	Inc	EeAdr

; Attente pour rgler la vitesse de dfilemnent des nombres
	Move	#20,W
	Call	LongDelai
	DecSkip,EQ C0
	Jump	L$

	Move	#16'FF,W	; Not sir Picg
	Move	W,PortB
	Jump	APC

\b;.Ins	XDelaiR.asi
\prog;XDelaiR.asi|030201

\rout:Del20| 20 \mu;s pour convertisseur AD
\mod:W
Del20:	Move	#6,W
 A$:	Add	#-1,W
	Skip,EQ
	Jump	A$
	Ret

\rout:Delai|Delai multiple de 100\mu;s
\in;W delai 0, 0,1 ... 25,5 ms
\mod;C1 C2 W
Delai:	Move	W,C1
 A$:	Move	#32,W	;Boucle interne 100\mu;s
	Move	W,C2
   B$:	DecSkip,EQ C2
	Jump	B$
	DecSkip,EQ C1
	Jump	A$
	Ret	

\rout:LongDelai|Delai multiple de 0.02 s
\in;W delai 0.02 .. 5 sec
\mod;C1 C2 C3 W
LongDelai:
	Move	W,C3
 L$:	Move	#200,W
	Move	W,C2
 A$:	Move	#32,W	;Boucle interne 100\mu;s
	Move	W,C1
   B$:	DecSkip,EQ C1
	Jump	B$
	DecSkip,EQ C2
	Jump	A$
	DecSkip,Eq C3
	Jump	L$
	Ret

\b;.Ins	XeeP84R.asi
\prog;XeeP84R.asi|280201 Ecriture en EEprom 84

\rout:WrEeprom| Ecriture 1 byte dans l'EEPROM
\in;EEADR adresse 6 bits  EEDATA data 8 bit
\mod;W
WrEeprom:
	Bank1			; changement de Bank
	Set	EeCon1:#WrEn	; mise  1 de write Enable
	Move	#16'55,W
	Move	W,EeCon2
	Move	#16'AA,W	; critures prliminaires de scurit
	Move	W,EeCon2
	Set	EeCon1:#WR
  w$:	TestSkip,BS  EeCon1:#EeIF	; Test si la criture est trmin
	jump	w$
	Clr	EeCon1:#EeIF
	Clr	EeCon1:#WrEn
	Bank0			; Retour au bank initial
	Ret

\rout:EERead| Lecture 1 byte depuis l'EEPROM
\in:EEAdr Adrese 0..63
\out; W EEDATA  Data lu
\mod: -
EERead:
	Bank1			; Changement de Bank
	SET	EeCon1:#RD	; lecture
	Bank0			; Retour dans le Bank initial
	Move	EeData,W	; Le resultat de la lecture est dans w
	Ret

\rout;WrEeBloc|Ecriture d'un bloc
\in; W longueur du bloc
\in;EEADR adresse 6 bits  FSR pointeur bloc data
\out;EEAdr et FSR incrments de la longueur
\mod;EEadr, FSR,  C1
WrEeBloc:
	Move	W,C1
 L$:	Move	{FSR},W
	Inc	FSR
	Move	W,EeData
	Call	WrEeProm
	Inc	EEAdr
	DecSkip,EQ C1
	Jump	L$
	Ret

\rout;RdEeBloc|Lecture d'un bloc
\in; W longueur du bloc
\in;EEADR adresse 6 bits  FSR pointeur bloc data
\out;EEAdr et FSR incrments de la longueur
\mod;EEadr, FSR, C1
RdEeBloc:
	Move	W,C1
 L$:	Bank1
	Set	EECON1:#RD	; lecture
	Bank0
	Move	EEDATA,W	;
	Move	W,{FSR}
	Inc	FSR
	Inc	EEAdr
	DecSkip,EQ C1
	Jump	L$
	Ret


.Align	16'8
.16	"P","i","c","T","8","4","e"," "
.Fill.16 	FinProg+1-APC,-1
.Loc	16'2007
.16	16'3FF9	; Mode XT

.End

